function [ ] = analyze_xo(fs,varargin)

%UNTITLED3 Summary of this function goes here
%   Detailed explanation goes here
impulses=varargin;

for n=1:(nargin-1)
    impulse = impulses{n};
    zeropad = 4*4096-floor(length(impulse)/2);
    impulse_p = [zeros(1,zeropad) impulse zeros(1,zeropad)];
    taps = length(impulse)/2;
    f=linspace(0,fs/2,taps);

    t=1/fs * (1:length(impulse));
    tplot{n} = t;
    figure(100)
    plot(t,impulse)
    [wv{n},yv{n}] = doFFT(fs,fftshift(impulse_p));
    %ydB(:,n) = 20*log10(abs(yv{n}));
    ydB{n} = 20*log10(abs(yv{n}));
    %impplot(:,n) = impulse;
    impplot{n} = impulse;
    stepplot{n} = cumsum(impulse);
    fplot{n} = wv{n}/2/pi;
%     if n==1
%         wtot = wv{1};
%         ytot = yv{1};
%         
%     else
%         ytot = ytot+yv{n};
%     end
end

figure(100)
subplot(2,1,1)
%plot(t,impplot)
hold on
cellfun(@plot,tplot,impplot)
title('Impulse responses')
xlabel('T, s')
grid
hold off

%figure(101)
subplot(2,1,2)
hold on
cellfun(@plot,tplot,stepplot)
title('Step responses')
xlabel('T, s')
grid
hold off


% cellfun(@plot,MyCell);
%fplot=wtot/2/pi;
figure(101)
subplot(3,1,1)
%semilogx(fplot,ydB,fplot,20*log10(abs(ytot)))
hold on
cellfun(@semilogx,fplot,ydB)
title('Magnitudes')
xlabel('f, Hz')
grid
set(gca,'XScale','log');
hold off
% figure(201)
% semilogx(wHP/2/pi,180/pi*angle(yHP), wLP/2/pi,180/pi*angle(yLP)); %*exp(-1i*t(ceil(end/2)))  +t0*wHP')

%calculate phase and group delay
for m=1:length(yv)
    ph_temp = angle(yv{m});
    ph_temp(abs(yv{m})<1e-9) = NaN;
    phases{m} = 180/pi*ph_temp;
    grpdel{m} = -1000*diff(unwrap(ph_temp))'./diff(wv{m});
    fshort{m} = fplot{m}(1:end-1);
end
subplot(3,1,2)
%semilogx(fplot,ydB,fplot,20*log10(abs(ytot)))
hold on
cellfun(@semilogx,fplot,phases)
title('Phase')
xlabel('f, Hz')
grid
set(gca,'XScale','log');
hold off

subplot(3,1,3)
%semilogx(fplot,ydB,fplot,20*log10(abs(ytot)))
hold on
cellfun(@semilogx,fshort,grpdel)
title('Group delay')
xlabel('f, Hz')
grid
set(gca,'XScale','log');
hold off

end

