% http://t-filter.engineerjs.com/
% http://se.mathworks.com/help/signal/ug/fir-filter-design.html
% https://www.minidsp.com/applications/advanced-tools/fir-filter-tools

fs=44100
%fs=48000
%fs=88200
%fs=96000
%fs=192000;

f_xo = 2000;
taps=512;
f=linspace(0,fs/2,taps);
%filtertype = 'LR4'
%filtertype = 'LR8'
%filtertype = 'brickwall'
%filtertype = 'butter8'
filtertype = 'gaussian'
revis ='A';
switch filtertype
    case 'brickwall'
        xoLP = (f<f_xo);
        xoHP = f>=f_xo;
    case 'gaussian'
        bw_xo = 200; %crossover width in Hz
        xoLP = 0.5*(1+erf(-(f-f_xo)/bw_xo));
        xoHP = 1-xoLP;
    case 'LR4'
        xoHP = abs(makeButterHP(f,2,f_xo).^2);
        xoLP = abs(makeButterLP(f,2,f_xo).^2);
	case 'LR8'
        xoHP = abs(makeButterHP(f,4,f_xo).^2);
        xoLP = abs(makeButterLP(f,4,f_xo).^2);
	case 'butter8'
        xoHP = abs(makeButterworth(f,f_xo,8,'high'));
        xoLP = abs(makeButterworth(f,f_xo,8,'low'));
end

figure(40)
semilogx(f,20*log10(abs(xoLP)),f,20*log10(abs(xoHP)))
title('Crossover magnitude')
xlabel('f, Hz')

[A_bas, A_diskant] = makedriverfilters(f,fs,taps);

spectHP = A_diskant.*xoHP;
spectLP = A_bas.*xoLP;
figure(50)
semilogx(f,20*log10(abs(spectLP+eps)),f,20*log10(abs(spectHP+eps)))
title('Ideal magnitude')
xlabel('f, Hz')


impLP = makeimpulseresp(spectLP);
impHP = makeimpulseresp(spectHP);

analyze_xo(fs,impLP,impHP);
questTitle='Replace Dialog'; start(timer('StartDelay',1,'TimerFcn',@(o,e)set(findall(0,'Tag',questTitle),'WindowStyle','normal'))); 
choice = questdlg('Replacement OK?', questTitle, 'Yes','No','Cancel','Yes');
%button = questdlg('Save?','WindowStyle','normal');


if strcmp(choice,'Yes')
    formatOut = 'yyyymmdd';
    filtnameLP = ['fir_' filtertype '_LP_' num2str(f_xo) 'Hz_' num2str(taps) 'taps_' num2str(fs) '_' datestr(now,formatOut) revis '.wav']
    filtnameHP = ['fir_' filtertype '_HP_' num2str(f_xo) 'Hz_' num2str(taps) 'taps_' num2str(fs) '_' datestr(now,formatOut) revis '.wav']
    audiowrite(filtnameLP,impLP,fs,'BitsPerSample',32);
    audiowrite(filtnameHP,impHP,fs,'BitsPerSample',32);
end