function [A_bas, A_diskant] = makedriverfilters(f,fs,taps)
f=linspace(0,fs/2,taps);



[a0, a1, a2, b0, b1, b2] = iirfilter_eapo('HIGH_SHELF', 6, 1400,fs, 12*0.9, '');
A1 = eval_iir(f,fs,a0, a1, a2, b0, b1, b2,1);
[a0, a1, a2, b0, b1, b2] = iirfilter_eapo('HIGH_SHELF', -17, 274.18,fs, 3, 'CF');
A2 = eval_iir(f,fs,a0, a1, a2, b0, b1, b2,2);


A_bas = A1.*A2;

[a0, a1, a2, b0, b1, b2] = iirfilter_eapo('HIGH_SHELF', -3, 6000,fs, 6, '');
A4 = eval_iir(f,fs,a0, a1, a2, b0, b1, b2,4);
A5 = 10^(-3.6/20);
A_diskant = A4.*A5;


figure(10)
subplot(3,1,1)
semilogx(f,20*log10(abs(A_bas)))
title('Amplitude, dB')
subplot(3,1,2)
semilogx(f,180/pi*angle(A_bas))
title('Phase, deg')
subplot(3,1,3)
semilogx(f(1:end-1),-1000*diff(unwrap(angle(A_bas)))./diff(2*pi*f))
title('Group delay, ms')

figure(11)
subplot(3,1,1)
semilogx(f,20*log10(abs(A_diskant)))
title('Amplitude, dB')
subplot(3,1,2)
semilogx(f,180/pi*angle(A_diskant))
title('Phase, deg')
subplot(3,1,3)
semilogx(f(1:end-1),-1000*diff(unwrap(angle(A_diskant)))./diff(2*pi*f))
title('Group delay, ms')

figure(12)
semilogx(f,20*log10(abs(A_diskant)),f,20*log10(abs(A_bas)))
title('Amplitude, dB')
ylim([-50 0])
end
